## unl0kr 2.0.2+dfsg

=== debian/changelog ===
unl0kr (2.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.0.2+dfsg

 -- Jarrah Gosbell <debian@undef.tools>  Tue, 10 Oct 2023 08:57:29 +0000

unl0kr (2.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.0.1+dfsg
  * d/patches: Remove patches obsoleted by 2.0.1

 -- Jarrah Gosbell <debian@undef.tools>  Mon, 02 Oct 2023 00:19:51 +0000

unl0kr (2.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.0.0+dfsg
  * d/copyright: Add copyright for upstream man pages
  * d/patches: Remove patches for upstreamed man pages
  * d/*: Copy removal cleanup and translations from osk-sdl
  * d/copyright: Add copyright for d/po
  * d/control: Depend on cryptsetup-initramfs
  * d/patches: Add patch to work around language dropdown bug

 -- Jarrah Gosbell <debian@undef.tools>  Wed, 27 Sep 2023 06:31:05 +0000

unl0kr (1.0.0+dfsg-1) unstable; urgency=medium

  * Initial Release (Closes: #1032115)

 -- Jarrah Gosbell <debian@undef.tools>  Thu, 22 Jun 2023 09:07:56 +0000
