=== lvgl/docs/requirements.txt ===
alabaster==0.7.12
Babel==2.9.1
breathe==4.30.0
certifi==2020.12.5
chardet==4.0.0
commonmark==0.9.1
docutils==0.16
idna==2.10
imagesize==1.2.0
importlib-metadata==4.8.1
Jinja2==2.11.3
Markdown==3.3.4
MarkupSafe==1.1.1
packaging==20.9
Pygments==2.9.0
pyparsing==2.4.7
pytz==2021.1
recommonmark==0.6.0
requests==2.25.1
six==1.16.0
snowballstemmer==2.1.0
Sphinx==4.5.0
sphinx-markdown-tables==0.0.15
sphinx-rtd-theme==0.5.2
sphinx-sitemap==2.2.0
sphinxcontrib-applehelp==1.0.2
sphinxcontrib-devhelp==1.0.2
sphinxcontrib-htmlhelp==2.0.0
sphinxcontrib-jsmath==1.0.1
sphinxcontrib-qthelp==1.0.3
sphinxcontrib-serializinghtml==1.1.5
typing-extensions==3.10.0.0
urllib3==1.26.5
zipp==3.4.1
