=== debian/changelog ===
unl0kr (2.0.3+dfsg-3) unstable; urgency=medium

  [ erebion ]
  * Added kernel modules required on sargo
  * include files from unl0kr config dir in initramfs
  * more robust if condition as a-wai suggested

 -- Jarrah Gosbell <debian@undef.tools>  Mon, 08 Sep 2025 08:00:48 +0000

unl0kr (2.0.3+dfsg-2) unstable; urgency=medium

  * d/initramfs: Add modules required for rockchip devices on 6.12

 -- Jarrah Gosbell <debian@undef.tools>  Mon, 06 Jan 2025 07:58:53 +0000

unl0kr (2.0.3+dfsg-1) unstable; urgency=medium

  [ Arnaud Ferraris ]
  * initramfs: hooks: add modules needed for Qualcomm-based phones

  [ Jarrah Gosbell ]
  * New upstream version 2.0.3+dfsg

 -- Jarrah Gosbell <debian@undef.tools>  Thu, 21 Dec 2023 08:57:32 +0000
