=== debian/control ===
Source: unl0kr
Section: utils
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Jarrah Gosbell <debian@undef.tools>
Build-Depends: debhelper-compat (= 13),
    libinih-dev,
    libinput-dev,
    libudev-dev,
    libxkbcommon-dev,
    meson,
    scdoc,
Standards-Version: 4.6.2
Homepage: https://gitlab.com/cherrypicker/unl0kr
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/unl0kr
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/unl0kr.git
Rules-Requires-Root: no

Package: unl0kr
Architecture: any
Depends: ${misc:Depends},
    ${shlibs:Depends},
    cryptsetup-initramfs,
Description: Lightweight framebuffer On-Screen-Keyboard based on LVGL
 This keyboard is designed to unlock encrypted root partitions on boot
 on mobile devices. It is automatically launched on boot, allowing the
 user to enter their disk encryption password.
