=== debian/watch ===
version=4
opts=dversionmangle=auto,searchmode=plain,repacksuffix=+dfsg,repack,compression=xz \
https://gitlab.com/api/v4//projects/29322771/releases \
https://gitlab.com/cherrypicker/unl0kr/uploads/[0-9a-z]*/@PACKAGE@-@ANY_VERSION@.tar.gz
